(function ($, Drupal, drupalSettings) {

  'use strict';

  function initTabs(elem){
    document.addEventListener('click', function (e) {
      if (!e.target.matches(elem+' .t-btn')) return;
      else{
        if(!e.target.classList.contains('active')){
          findActiveElementAndRemoveIt(elem+' .t-btn');
          findActiveElementAndRemoveIt(elem+' .t-panel');
          e.target.classList.add('active');
          setTimeout(function(){
            var panel = document.querySelectorAll(elem+' .t-panel.'+e.target.dataset.name);
            Array.prototype.forEach.call(panel, function (el) {
              el.classList.add('active');
            });
          }, 200);
        }
      }
    });
  }

  function findActiveElementAndRemoveIt(elem){
    var elementList = document.querySelectorAll(elem);
    Array.prototype.forEach.call(elementList, function (e) {
      e.classList.remove('active');
    });
  }

  var module_initialized = false;

  Drupal.behaviors.ddna_tabbed_table = {
    attach: function (context, settings) {
      if(module_initialized) {
        return;
      }

      module_initialized = true;
      initTabs('.ddna-tabbed-table.ddna-tabbed-table--horizontal');
      // initTab('.ddna-tabbed-table.ddna-tabbed-table--horizontal');
    }
  }
}(jQuery, Drupal, drupalSettings));
